#ifndef _BASE_SCENE_CLASS_
#define _BASE_SCENE_CLASS_

#include <system/file.h>
#include <system/platform.h>
#include <graphics/vita/sprite_renderer_vita.h>
#include <list>

using abfw::File;
using abfw::Platform;
using std::list;

#include "game_object.h"
#include "font_object.h"
#include "inputclass.h"

class BaseSceneClass
{
public:
	virtual ~BaseSceneClass()
	{
	}

	virtual bool Initialize(Platform& platform, InputClass* input, const char* filename) = 0;
	virtual int Frame(float dt) = 0;
	virtual void Shutdown() = 0;

	virtual void Render(abfw::SpriteRendererVita* renderer_, abfw::Font& font) = 0;

protected:
	std::list<GameObject *> game_objects;
	InputClass* input_;
	Platform* platform_;
};

#endif