#include "game_object.h"

GameObject::GameObject()
{
	phys_object = NULL;
	set_width(32);
	set_height(32);
}

GameObject::~GameObject()
{
}

void GameObject::Initialize(float x, float y, int _width, int _height, string tag, UInt32 color, float platform_height)
{
	position.x = x;
	position.y = y;

	plat_height = platform_height;

	phys_object = new PhysicsObject2D();
	
	phys_object->Initialize(abfw::Vector2(x, y), 1.0f, tag, _width, _height);

	set_width(_width);
	set_height(_height);

	_sprite.set_width(width());
	_sprite.set_height(height());

	_sprite.set_position(x, y, 0.f);

	_sprite.set_colour(color);
}

void GameObject::Frame()
{
	position = phys_object->GetPosition();

	set_position(abfw::Vector3(position.x, position.y, 0.f));

	_sprite.set_position(position.x, (plat_height - position.y), 0.f);

	phys_object->ClearCollisionTags();

}

void GameObject::Shutdown()
{
	if (phys_object)
	{
		phys_object->Shutdown();
		delete phys_object;
		phys_object = NULL;
	}
}

void GameObject::CreationFrame()
{
	_sprite.set_width(width());
	_sprite.set_height(height());

	_sprite.set_position(position.x, (plat_height - position.y), 0.f);

}

void GameObject::SetPosition(float x, float y)
{
	position.x = x;
	position.y = y;
}

abfw::Vector3 GameObject::GetPosition()
{
	return abfw::Vector3(position.x, position.y, 0.f);
}

abfw::Sprite GameObject::GetSprite()
{
	return _sprite;
}