#ifndef _GAME_OBJECT_H_
#define _GAME_OBJECT_H_

#include <graphics/sprite.h>
#include <maths/vector2.h>

#include "2d_physics_object.h"

class GameObject : public abfw::Sprite
{
public:
	GameObject();
	virtual ~GameObject();

	void Initialize(float x, float y, int width, int height, string tag, UInt32 color, float platform_height);
	void Frame();
	void Shutdown();
	void CreationFrame();
	void SetPosition(float x, float y);

	abfw::Vector3 GetPosition();
	abfw::Sprite GetSprite();

	inline PhysicsObject2D* GetPhysObjPtr()
	{
		return phys_object;
	}


private:
	abfw::Sprite _sprite;
	abfw::Vector2 position;
	PhysicsObject2D* phys_object;
	float plat_height;
};

#endif