#ifndef _GRAPHICSCLASS_H_
#define _GRAPHICSCLASS_H_

#include <graphics/sprite.h>
#include <graphics/sprite_renderer.h>
#include <graphics/font.h>
#include <system/platform.h>
#include <iostream>

namespace abfw
{
	class Platform;
}

class GraphicsClass
{
public:
	GraphicsClass(abfw::Platform& platform);
	~GraphicsClass();

	void Initialize();
	void Shutdown();
	bool Update(float ticks);
	void Render();

private:
	abfw::Sprite sprite_;
	abfw::Font font_;
	abfw::SpriteRenderer* sprite_renderer_;
	float frame_rate_;
};

#endif