#ifndef _SCENE_CREATOR_CLASS_H_
#define _SCENE_CREATOR_CLASS_H_

#include "base_scene_class.h"

class SceneCreatorClass : public BaseSceneClass
{
private:
	enum class placement_state { WALL, PLAYER, GOAL, ZONE, NOMODE };

public:
	SceneCreatorClass();
	SceneCreatorClass(const SceneCreatorClass& other);
	~SceneCreatorClass();

	bool Initialize(Platform& platform, InputClass* input, const char* filename);
	int Frame(float dt);
	void Shutdown();

	void Render(abfw::SpriteRendererVita* renderer_, abfw::Font& font);

	bool LoadLevelList();
	void ClearScene();

private:
	void ChangeMode(placement_state mode);
	void ChangeModeNoDelete(placement_state mode);

	bool SaveLevel();


private:
	placement_state current_mode;
	abfw::Vector2 current_position;
	float platform_width_, platform_height_;
	bool player_placed, goal_placed, wall_placed;
	float deltaTime;
	std::list<string> filenames_;
	int level_count_;
	float dt_;
};

#endif