#ifndef _SCENECLASS_H_
#define _SCENECLASS_H_

#include "base_scene_class.h"
#include "2d_physics_environment.h"


class SceneClass : public BaseSceneClass
{
public:
	SceneClass();
	SceneClass(const SceneClass& other);
	~SceneClass();

	bool Initialize(Platform& platform, InputClass* input, const char* filename);
	int Frame(float dt);
	void Shutdown();

	void Render(abfw::SpriteRendererVita* renderer_, abfw::Font& font);

private:
	void LoadSceneFile(const char* filename);
	void ResetLevel();

private:
	PhysicsEnvironment2D phys_environment;
	abfw::Vector2 start_position_;
	GameObject* player_ptr_;
	float timer_;
	bool end_of_level_;

};

#endif