#ifndef _ABFW_CONTROLLER_MANAGER_VITA_H
#define _ABFW_CONTROLLER_MANAGER_VITA_H

#include "sony_controller_input_manager.h"
#include <scetypes.h>
#include <ctrl.h>

namespace abfw
{
    class SonyControllerInputManagerVita : public SonyControllerInputManager
    {
    public:

        /// SonyControllerInputManagerVita class constructor
        SonyControllerInputManagerVita();

        /// SonyControllerInputManagerVita class constructor
        ///
        /// @param[in] sampling_mode the sampling mode to initialise the the controllers with
        SonyControllerInputManagerVita(const SceUInt32 sampling_mode);


        /// SonyControllerInputManagerVita class destructor
        ~SonyControllerInputManagerVita();

        /// Update the controller data with the current status of the buttons and analog sticks
        ///
        /// @return error status from reading the controllers [0 = success]
        int Update();

    private:
        int Init(const SceUInt32 sampling_mode);

        void UpdateController(SonyController& controller, const SceCtrlData& controller_data);

        static float kStickDeadZone;

    };
}

#endif // _ABFW_CONTROLLER_INPUT_H